<?php
$client = [
	'virtIpaddr' 	=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_VIRTIPADDR_DIS',
		'tooltip'				=> 'VPN_DATA_VIRTIPADDR_TOOLTIP',
		'validator'			=> null,
		'validator-java'=> null,
	],
	'realIpaddr' 	=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_REALIPADDR_DIS',
		'tooltip'				=> 'VPN_DATA_REALIPADDR_TOOLTIP',
		'validator'			=> null,
		'validator-java'=> null,
	],
	'connectedSince'=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_CONNECTEDSINCE_DIS',
		'tooltip'				=> 'VPN_DATA_CONNECTEDSINCE_TOOLTIP',
		'validator'			=> null,
		'validator-java'=> null,
	],
	'lastRef'			=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_LASTREF_DIS',
		'tooltip'				=> 'VPN_DATA_LASTREF_TOOLTIP',
		'validator'			=> 'ip4',
		'validator-java'=> null,
	],
	'bytesRcvd'		=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_BYTESRCVD_DIS',
		'tooltip'				=> 'VPN_DATA_BYTESRCVD_TOOLTIP',
		'validator'			=> null,
		'validator-java'=> null,
	],
	'bytesSent'		=> [
		'default' 			=> null,
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> null,
		'options' 			=> null,
		'title'					=> 'VPN_DATA_BYTESSENT_DIS',
		'tooltip'				=> 'VPN_DATA_BYTESSENT_TOOLTIP',
		'validator'			=> null,
		'validator-java'=> null,
	],
];

$server	= [
	'ipaddr' 	=> [
		'default' 			=> '10.0.0.1',
		'disabled'			=> true,
		'display'				=> 'fieldText',
		'key' 					=> 'ipaddr',
		'options' 			=> null,
		'title'					=> 'VPN_DATA_IPADDR_DIS',
		'tooltip'				=> 'VPN_DATA_IPADDR_TOOLTIP',
		'validator'			=> 'ip4',
		'validator-java'=> null,
	],
	'iprange' 	=> [
		'default' 			=> '10.0.0.0',
		'disabled'			=> false,
		'display'				=> 'fieldText',
		'key' 					=> 'iprange',
		'options' 			=> null,
		'title'					=> 'VPN_DATA_IPRANGE_DIS',
		'tooltip'				=> 'VPN_DATA_IPRANGE_TOOLTIP',
		'validator'			=> 'ip4',
		'validator-java'=> 'required:true, verifyIP: true',
	],
	'ipnetmask' 	=> [
		'default' 			=> '255.255.255.0',
		'display'				=> 'fieldText',
		'key' 					=> 'ipnetmask',
		'options' 			=> null,
		'title'					=> 'VPN_DATA_IPNETMASK_DIS',
		'tooltip'				=> 'VPN_DATA_IPNETMASK_TOOLTIP',
		'validator'			=> 'ip4',
		'validator-java'=> 'required:true, verifyIP: true',
	],
	/*
	'port' 		=> [
		'default' 			=> '1194',
		'display'				=> 'fieldText',
		'key' 					=> 'port',
		'options' 			=> [
			'int-range'	=> ['min' => 1084, 'max' => 65535],
		],
		'title'					=> 'VPN_DATA_PORT_DIS',
		'tooltip'				=> 'VPN_DATA_PORT_TOOLTIP',
		'validator'			=> 'int-range',
		'validator-java'=> 'required:true, range: [1084, 65535]',
	],
	 */
	'protocol' 	=> [
		'default' 			=> 'UDP',
		'display'				=> 'fieldSelect',
		'key' 					=> 'protocol',
		'title'					=> 'VPN_DATA_PROTOCOL_DIS',
		'tooltip'				=> 'VPN_DATA_PROTOCOL_TOOLTIP',
		'options' 			=> [
			'select' => [
				'udp' => 'PROTOCOL_UDP',
				'tcp' => 'PROTOCOL_TCP',
			],
		],
		'validator'			=> 'select',
		'validator-java'=> null,
	],
];

if (!file_exists('/etc/openvpn/server.conf')) {
	unset($server['ipaddr']);
}

return [
	'client' => $client,
	'server' => $server,	
];
